﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Gallio.Framework;
using MbUnit.Framework;
using SkillsMatter.PostSharp.Validation;

namespace SkillsMatter.PostSharp.Tests.Unit
{
	[TestFixture]
	public class EntityValidationTests
	{
		[Test]
		public void NumericalRangeTest()
		{
			FoodQuestionaire q = new FoodQuestionaire();

			q.LikesBeef = 5;
			Assert.AreEqual(5, q.LikesBeef);
			Assert.Throws<ValidationException>(() => q.LikesBeef = 100);
			Assert.Throws<ValidationException>(() => q.LikesBeef = -3);
			Assert.AreEqual(5, q.LikesBeef);

			q.Postcode = "E14 0AN";
			Assert.AreEqual("E14 0AN", q.Postcode);
			Assert.Throws<ValidationException>(() => q.Postcode = "Hello World");
			Assert.AreEqual("E14 0AN", q.Postcode);
		}

		[Test]
		public void UKPostcodeValidationTest()
		{
			FoodQuestionaire q = new FoodQuestionaire();

			q.Postcode = "E14 0AN";
			Assert.AreEqual("E14 0AN", q.Postcode);
			Assert.Throws<ValidationException>(() => q.Postcode = "Hello World");
			Assert.AreEqual("E14 0AN", q.Postcode);
		}
	}
}