﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;
using Invocation = SkillsMatter.PostSharp.OnMethodInvocation;
using Boundary = SkillsMatter.PostSharp.OnMethodBoundary;

namespace SkillsMatter.PostSharp.Tests.Unit
{
	[TestFixture]
	public class SimpleInjectionTests
	{
		[Test]
		public void Verify_Aspect_Called_On_Method_Invocation()
		{
			var d = new Invocation.Demo();
			d.Foo();
			d.StaticFoo();

			ActivityRecorder.AssertActivityOccured("In constructor");

			ActivityRecorder.AssertActivityOccured("Calling Void Foo()");
			ActivityRecorder.AssertActivityOccured("In Foo");
			
			ActivityRecorder.AssertActivityOccured("Calling Void StaticFoo()");
			ActivityRecorder.AssertActivityOccured("In StaticFoo");
			
			ActivityRecorder.AssertNoMoreActivities();
		}

		[Test]
		public void Verify_Aspect_Called_On_Method_Boundary()
		{
			var d = new Boundary.Demo();
			d.Foo();
			d.StaticFoo();

			ActivityRecorder.AssertActivityOccured("Before Void .ctor()"); 
			ActivityRecorder.AssertActivityOccured("In constructor");
			ActivityRecorder.AssertActivityOccured("After Void .ctor()");

			ActivityRecorder.AssertActivityOccured("Before Void Foo()");
			ActivityRecorder.AssertActivityOccured("In Foo");
			ActivityRecorder.AssertActivityOccured("After Void Foo()");

			ActivityRecorder.AssertActivityOccured("Before Void StaticFoo()");
			ActivityRecorder.AssertActivityOccured("In StaticFoo");
			ActivityRecorder.AssertActivityOccured("After Void StaticFoo()");

			ActivityRecorder.AssertNoMoreActivities();
		}

		[SetUp]
		public void Setup()
		{
			ActivityRecorder.Reset();
		}
	}
}