﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Gallio.Framework;
using MbUnit.Framework;
using PostSharp.Laos;


namespace SkillsMatter.PostSharp.Aspects
{
	[Serializable]
	public class RegularExpressionValidator : OnMethodBoundaryAspect
	{
		public string Regex { get; set; }

		public RegularExpressionValidator(string regex)
		{
			Regex = regex;
		}

		public override void OnEntry(MethodExecutionEventArgs eventArgs)
		{
			if (!eventArgs.Method.Name.StartsWith("set_"))
				return;

			var args = eventArgs.GetReadOnlyArgumentArray();
			if (args.Count() == 0)
				throw new ValidationException("No argument passed to set");

			string value = (string)args[0];
			if(!System.Text.RegularExpressions.Regex.IsMatch(value, Regex))
				throw new ValidationException("Value must match regex " + Regex);

			base.OnEntry(eventArgs);
		}

	}
}
